config/routes.rb
# frozen_string_literal: true
Rails.application.routes.draw do
  resources :cases

  # resources :registrations
  resources :committees do
    resources :registrations, only: :index
    resources :meetings do
      match :edit_agenda, via: :get
      match :generate_agenda, via: :get

      resources :registrations
      match :increment_max_candidates_number, via: :get
      match :decrement_max_candidates_number, via: :get
      match :approve, via: :get
    end
  end

  root 'home#index'
  match 'home/private_index' => 'home#private_index', via: :get

  match 'get_permitted_keywords' => 'home#permitted_keywords_get', via: :get
  match 'set_permitted_keywords' => 'home#permitted_keywords_set', via: :get

  # omniauth
  get '/auth/:provider/callback' => 'user_sessions#create'
  get '/auth/failure' => 'user_sessions#failure'
  get 'auth/autologin' => 'user_sessions#autologin'

  # Custom logout
  match '/logout', to: 'user_sessions#destroy', via: :all
end

app/controllers/home_controller.rb
# frozen_string_literal: true
class HomeController < ApplicationController
  skip_before_action :login_required, only: %w(index permitted_keywords_get permitted_keywords_set)

  def index
    redirect_to committees_path if current_user.present?
  end

  def private_index; end

  def permitted_keywords_get
    session[:permitted_keywords_last_parsed_timestamp] = Time.zone.now.to_i
    redirect_to Rails.application.secrets.permitted_keywords_server_url + '/permitted_keywords.json'
  end

  def permitted_keywords_set
    flash[:alert] = params[:alert]
    session[:permitted_keywords] = JSON.parse(URI.unescape(params[:keywords]))
    redirect_to params[:redirect_to_url] || session[:redirect_to_url] || root_path
  end
end

app/views/home/index.html.haml
- if current_user.present?
  %h1= t(:welcome)
  %p
    Username: #{current_user.email}
  .btn-group
    = link_to 'Private page', home_private_index_path,
    class: 'btn btn-secondary'
    = link_to 'Committees', committees_path, class: 'btn btn-primary'
    = link_to 'Logout', logout_path, method: :delete, class: 'btn btn-danger'
- else
  .card.col-md-6.offset-md-3
    %h3.card-header= t(:login_required)
    .card-block
      %h4.card-title= t(:plese_log_in)
      %p.card-text
        = t(:log_in_more_info)
        %hr
        = t(:with_any_troubles)
        = mail_to(Rails.application.secrets.admin_email)
      = link_to t(:sign_in), '/auth/sso', method: :post,
      class: 'btn btn-success'

app/views/home/private_index.html.haml
%h2 Hello user!
%p Visible only for signed users.
= link_to 'home page', root_path